#ifndef __JACU_PRIV_H
#define __JACU_PRIV_H

#include <vector>
using std::vector;

namespace jacu {
	//  ü
	struct TestFunc
	{
		string FuncName;
		TFP FuncPtr;
		TestFunc(const char* func,
   			TFP fp)
		: FuncName(func), FuncPtr(fp) {}
 	};

	typedef vector<TestFunc> TFUNCS;

	class TestSuite
 	{
		string Name;
		TFP setUpFp, tearDownFp;
		TestSuite(const TestSuite&);
		TestSuite& operator= (const TestSuite&);
		TFUNCS funcs;
		static void nullSetUp() {}
		static void nullTearDown() {}
	public:
		TestSuite() : setUpFp(&nullSetUp), tearDownFp(&nullTearDown), funcs() {};
		TestSuite(string suiteName) : Name(suiteName), setUpFp(&nullSetUp)
			, tearDownFp(&nullTearDown), funcs() {};
		void add(const char*, TFP);
		void runAll();
	};

	class TestManager
	{

		typedef map<string, TestSuite*> TSUITES;
		TSUITES suites;
		TestManager() : suites() {}
		TestManager(const TestManager&);
		TestManager& operator=(const TestManager&);
	public:
		~TestManager();
		static TestManager* Instance();
		void add(const char* suiteName, const char* funcName, TFP funcPtr);
		void runAll();
		void runSuite(const string& suiteName);
		void addResult(const char* condStr, const char* file, int line);
	};

}
#endif // __JACU_PRIV_H
