#include "../include/jacu.h"
#include "jacu_priv.h"
using namespace jacu;

using std::string;
using std::cerr;
using std::cout;
using std::endl;

// TestManager 
TestManager* TestManager::Instance()
{
	static TestManager inst;
	return &inst;
}

void TestManager::add(const char* suiteName, const char* funcName, TFP funcPtr)
{
	TSUITES::iterator itr = suites.find(suiteName);

	if( itr == suites.end() )
		suites[suiteName] = new TestSuite(suiteName);

	suites[suiteName]->add(funcName, funcPtr);
}


TestManager::~TestManager()
{
	for(TSUITES::iterator itr=suites.begin();
		itr != suites.end(); itr++)
	{
		delete itr->second;
	}
 	suites.clear();
}

void TestManager::runAll()
{
	for(TSUITES::iterator itr=suites.begin();
		itr != suites.end(); itr++)
	{
		itr->second->runAll();
	}

}

void TestManager::runSuite(const string& name)
{
	TSUITES::iterator itr = suites.find(name);
	if (itr != suites.end() )
		itr->second->runAll();
	else
		cerr << "Unknown Suite " << name << ".\n";
}
