#include "../include/jacu.h"
#include "jacu_priv.h"

using namespace jacu;
using std::string;

// TestSuite 
void TestSuite::add(const char* funcName, TFP fp)
{
	string func(funcName);

	if (func=="setUp")
	{
		setUpFp = fp;
	}
	else if (func=="tearDown")
	{
		tearDownFp = fp;
	}
	else
	{
		funcs.push_back( TestFunc(funcName, fp) );
	}
};

void TestSuite::runAll()
{
	CurrentTest::Instance()->SuiteName = Name;
    CurrentTest::Instance()->Reporter()->startSuite(Name);
    
	for(TFUNCS::iterator iter = funcs.begin();
		iter != funcs.end();
		++iter)
	{
		CurrentTest::Instance()->TestName="setUp";
		(*setUpFp)();

		CurrentTest::Instance()->TestName= iter->FuncName;
		(iter->FuncPtr)();

		CurrentTest::Instance()->TestName="tearDown";
		(*tearDownFp)();
	}
    CurrentTest::Instance()->Reporter()->endSuite(Name);
}
